/* -------------------------------------------------------------------------- */
/*                             JAVASCRIPT VISION                              */
/*                              Browser Sniffer                               */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Gary S. Krajci                                                     */
/* Email: gary.s.krajci@bigfoot.com                                           */
/* Company: Roaring Fork Software                                             */
/* Date: February 23, 2001                                                    */
/* URL: http://www.roaringforksoftware.com/JSV/                               */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */
/*
Saved from url = http://www.webreference.com/tools/browser/javascript.html

Adapted from Netscape's Ultimate client-side JavaScript client sniff and 
Andy's sniffer

Revised May 7 99 to add is.nav5up and is.ie5up (see below). (see below).
Revised June 11 99 to add addit props, checks
Revised June 23 99 added screen props - gecko m6 doesn't support yet - abk
                   converted to var is_ from is object to work everywhere
990624 - added cookie forms links frames checks - abk
001031 - ie4 mod 5.0 -> 5. (ie5.5 mididentified - abk)
         is_ie4 mod tp work with ie6+ - abk
001120 - ns6 released, document.layers false, put back in
       - is_nav6 test added - abk
001121 - ns6+ added, used document.getElementById, better test, dom-compl

Everything you always wanted to know about your JavaScript client
but were afraid to ask. Creates "is_" variables indicating:

(1) browser vendor:
    is_nav, is_ie, is_opera
(2) browser version number:
    is_major (integer indicating major version number: 2, 3, 4 ...)
    is_minor (float   indicating full  version number: 2.02, 3.01, 4.04 ...)
(3) browser vendor AND major version number
    is_nav2, is_nav3, is_nav4, is_nav4up, is_nav5, is_nav5up, is_ie3, is_ie4, is_ie4up
(4) JavaScript version number:
    is_js (float indicating full JavaScript version number: 1, 1.1, 1.2 ...)
(5) OS platform and version:
    is_win, is_win16, is_win32, is_win31, is_win95, is_winnt, is_win98
    is_os2
    is_mac, is_mac68k, is_macppc
    is_unix
       is_sun, is_sun4, is_sun5, is_suni86
       is_irix, is_irix5, is_irix6
       is_hpux, is_hpux9, is_hpux10
       is_aix, is_aix1, is_aix2, is_aix3, is_aix4
       is_linux, is_sco, is_unixware, is_mpras, is_reliant
       is_dec, is_sinix, is_freebsd, is_bsd
    is_vms

See http:www.it97.de/JavaScript/JS_tutorial/bstat/navobj.html and
http:www.it97.de/JavaScript/JS_tutorial/bstat/Browseraol.html
for detailed lists of userAgent strings.

Note: you don't want your Nav4 or IE4 code to "turn off" or stop working when 
Nav5 and IE5 (or later) are released, so in conditional code forks, 
use is_nav4up ("Nav4 or greater") and is_ie4up ("IE4 or greater") instead of 
is_nav4 or is_ie4 to check version in code which you want to work on future
versions.

New version checking from michel plungjan 010117
Finds actual version for ie3-5.5
*/

// convert all characters to lowercase to simplify testing
var agt = navigator.userAgent.toLowerCase();

// *** BROWSER VERSION ***
// Note: On IE5, these return 4, so use is.ie5up to detect IE5.
var iePos    = agt.indexOf('msie');
var is_ie    = ( iePos != -1 );
var is_major = parseInt(navigator.appVersion);
var is_minor = parseFloat(navigator.appVersion);

if ( is_ie ) {
	var navigatorAppVersion = navigator.appVersion.toLowerCase();
	iePos = navigatorAppVersion.indexOf('msie');
	is_minor = parseFloat(navigatorAppVersion.substring(iePos+5,navigatorAppVersion.indexOf(';',iePos)));
	is_major = parseInt(is_minor);
}

var is_getElementById   = (document.getElementById) ? "true" : "false"; // 001121-abk
var is_getElementsByTagName = (document.getElementsByTagName) ? "true" : "false"; // 001127-abk
var is_documentElement = (document.documentElement) ? "true" : "false"; // 001121-abk

var is_nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1) &&
			(agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1) && 
			(agt.indexOf('webtv')==-1));
var is_nav2 = ( is_nav && is_major == 2 );
var is_nav3 = ( is_nav && is_major == 3 );
var is_nav4 = ( is_nav && is_major == 4 );
var is_nav4up = ( is_nav && is_major >= 4 );
var is_navonly = ( is_nav && ((agt.indexOf(";nav") != -1) || (agt.indexOf("; nav") != -1)) );
var is_nav6 = ( is_nav && (agt.indexOf('netscape6') != -1)); // new 001120 - abk
var is_nav6up = ( is_nav && is_getElementById );              // new 001121 - abk
var is_nav5 = ( is_nav && is_major == 5 && !is_nav6 ); // checked for ns6
var is_nav5up = ( is_nav && is_major >= 5 );

var is_ie3 = ( is_ie && is_major < 4 );
var is_ie4 = ( is_ie && is_major == 4 );
var is_ie4up = ( is_ie  && is_major >= 4 );
var is_ie5 = ( is_ie && is_major == 5 );
var is_ie5up = ( is_ie && is_major > 4 );

// KNOWN BUG: On AOL4, returns false if IE3 is embedded browser 
// or if this is the first browser window opened.  Thus the 
// variables is_aol, is_aol3, and is_aol4 aren't 100% reliable. 
 
var is_aol   = (agt.indexOf("aol") != -1);
var is_aol3  = (is_aol && is_ie3);
var is_aol4  = (is_aol && is_ie4);

var is_opera = (agt.indexOf("opera") != -1);
var is_webtv = (agt.indexOf("webtv") != -1);

// *** JAVASCRIPT VERSION CHECK ***
// Useful to workaround Nav3 bug in which Nav3
// loads <SCRIPT LANGUAGE="JavaScript1.2">.
var is_js;
if (is_nav2 || is_ie3) is_js = 1.0
else if (is_nav3 || is_opera) is_js = 1.1
else if ((is_nav4 && (is_minor <= 4.05)) || is_ie4) is_js = 1.2
else if ((is_nav4 && (is_minor > 4.05)) || is_ie5) is_js = 1.3
else if (is_nav5 && !(is_nav6)) is_js = 1.4
else if (is_nav6) is_js = 1.5

// NOTE: In the future, update this code when newer versions of JS
// are released. For now, we try to provide some upward compatibility
// so that future versions of Nav and IE will show they are at
// *least* JS 1.x capable. Always check for JS version compatibility
// with > or >=.

else if (is_nav && (is_major > 5)) is_js = 1.4
else if (is_ie && (is_major > 5)) is_js = 1.3
// HACK: no idea for other browsers; always check for JS version with > or >=
else is_js = 0.0;

// *** PLATFORM ***
var is_win   = ( (agt.indexOf("win")!=-1) || (agt.indexOf("16bit")!=-1) );
// NOTE: On Opera 3.0, the userAgent string includes "Windows 95/NT4" on all
//       Win32, so you can't distinguish between Win95 and WinNT.
var is_win95 = ((agt.indexOf("win95")!=-1) || (agt.indexOf("windows 95")!=-1));

// is this a 16 bit compiled version?
var is_win16 = ((agt.indexOf("win16")!=-1) || 
			(agt.indexOf("16bit")!=-1) || (agt.indexOf("windows 3.1")!=-1) || 
			(agt.indexOf("windows 16-bit")!=-1) );  

var is_win31 = ((agt.indexOf("windows 3.1")!=-1) || (agt.indexOf("win16")!=-1) ||
                (agt.indexOf("windows 16-bit")!=-1));

// NOTE: Reliable detection of Win98 may not be possible. It appears that:
//       - On Nav 4.x and before you'll get plain "Windows" in userAgent.
//       - On Mercury client, the 32-bit version will return "Win98", but
//         the 16-bit version running on Win98 will still return "Win95".

var is_win98 = ((agt.indexOf("win98")!=-1) || (agt.indexOf("windows 98")!=-1));
var is_winnt = ((agt.indexOf("winnt")!=-1) || (agt.indexOf("windows nt")!=-1));
var is_win32 = (is_win95 || is_winnt || is_win98 || 
                ((is_major >= 4) && (navigator.platform == "Win32")) ||
                (agt.indexOf("win32")!=-1) || (agt.indexOf("32bit")!=-1));

var is_os2   = ((agt.indexOf("os/2")!=-1) || 
                (navigator.appVersion.indexOf("OS/2")!=-1) ||   
                (agt.indexOf("ibm-webexplorer")!=-1));

var is_mac    = (agt.indexOf("mac")!=-1);
var is_mac68k = (is_mac && ((agt.indexOf("68k")!=-1) || 
                           (agt.indexOf("68000")!=-1)));
var is_macppc = (is_mac && ((agt.indexOf("ppc")!=-1) || 
                            (agt.indexOf("powerpc")!=-1)));

var is_sun   = (agt.indexOf("sunos")!=-1);
var is_sun4  = (agt.indexOf("sunos 4")!=-1);
var is_sun5  = (agt.indexOf("sunos 5")!=-1);
var is_suni86= (is_sun && (agt.indexOf("i86")!=-1));
var is_irix  = (agt.indexOf("irix") !=-1);    // SGI
var is_irix5 = (agt.indexOf("irix 5") !=-1);
var is_irix6 = ((agt.indexOf("irix 6") !=-1) || (agt.indexOf("irix6") !=-1));
var is_hpux  = (agt.indexOf("hp-ux")!=-1);
var is_hpux9 = (is_hpux && (agt.indexOf("09.")!=-1));
var is_hpux10= (is_hpux && (agt.indexOf("10.")!=-1));
var is_aix   = (agt.indexOf("aix") !=-1);      // IBM
var is_aix1  = (agt.indexOf("aix 1") !=-1);    
var is_aix2  = (agt.indexOf("aix 2") !=-1);    
var is_aix3  = (agt.indexOf("aix 3") !=-1);    
var is_aix4  = (agt.indexOf("aix 4") !=-1);    
var is_linux = (agt.indexOf("inux")!=-1);
var is_sco   = (agt.indexOf("sco")!=-1) || (agt.indexOf("unix_sv")!=-1);
var is_unixware = (agt.indexOf("unix_system_v")!=-1); 
var is_mpras    = (agt.indexOf("ncr")!=-1); 
var is_reliant  = (agt.indexOf("reliantunix")!=-1);
var is_dec   = ((agt.indexOf("dec")!=-1) || (agt.indexOf("osf1")!=-1) || 
       (agt.indexOf("dec_alpha")!=-1) || (agt.indexOf("alphaserver")!=-1) || 
       (agt.indexOf("ultrix")!=-1) || (agt.indexOf("alphastation")!=-1)); 
var is_sinix = (agt.indexOf("sinix")!=-1);
var is_freebsd = (agt.indexOf("freebsd")!=-1);
var is_bsd = (agt.indexOf("bsd")!=-1);
var is_unix  = ((agt.indexOf("x11")!=-1) || is_sun || is_irix || is_hpux || 
             is_sco ||is_unixware || is_mpras || is_reliant || 
             is_dec || is_sinix || is_aix || is_linux || is_bsd || is_freebsd);

var is_vms   = ((agt.indexOf("vax")!=-1) || (agt.indexOf("openvms")!=-1));
// additional checks, abk
var is_anchors = (document.anchors) ? "true":"false";
var is_regexp = (window.RegExp) ? "true":"false";
var is_option = (window.Option) ? "true":"false";
var is_all = (document.all) ? "true":"false";
// cookies - 990624 - abk
document.cookie = "cookies=true";
var is_cookie = (document.cookie) ? "true" : "false";
var is_images = (document.images) ? "true":"false";
var is_layers = (document.layers) ? "true":"false"; // gecko m7 bug?
// new doc obj tests 990624-abk
var is_forms = (document.forms) ? "true" : "false";
var is_links = (document.links) ? "true" : "false";
var is_frames = (window.frames) ? "true" : "false";
var is_screen = (window.screen) ? "true" : "false";

// java
var is_java = (navigator.javaEnabled());
