/* -------------------------------------------------------------------------- */
/*                             JAVASCRIPT VISION                              */
/*                          Frame Management Methods                          */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Gary S. Krajci                                                     */
/* Email: gary.s.krajci@bigfoot.com                                           */
/* Company: Roaring Fork Software                                             */
/* Date: October 14, 1999                                                     */
/* URL: http://www.roaringforksoftware.com/JSV/                               */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */

var NOTINFRAME = -1;

/* -------------------------------------------------------------------------- */
/*                           Frame Document Methods                           */
/* -------------------------------------------------------------------------- */

function JSV_getCurrentFrameName() {
	return this.window.name;
}

function JSV_getFramesetWindowName() {
	return parent.window.name;
}

function JSV_setFramesetWindowName(framesetName) {
	if ( !JSV_isWhitespace(framesetName) ) 
		parent.window.name = framesetName;
}

function JSV_frameCount() {
	return parent.frames.length;
}

function JSV_isFrameSet() {
	return ( JSV_frameCount() > 0 && top == self );
}

function JSV_inFrame() {
	return (top != self);
}

function JSV_notInFrame() {
	return (top == self);
}

function JSV_frameBuster() {
	if ( JSV_inFrame() ) {
		parent.window.location.href = window.location.href;
	}
}

function JSV_useOnlyInFrame(frameSetPage, frameName, replace) {
	if ( JSV_notInFrame() ) {
		var loadURL =	frameSetPage + 
						"?frameSetPage=" + escape(window.location.pathname) +
						"&frameName=" + escape(frameName);
		if ( JSV_isWhitespace(replace) ? false : replace )
			window.location.replace(loadURL);
		else
			window.location.href = loadURL;
	}
}
