/* -------------------------------------------------------------------------- */
/*                             JAVASCRIPT VISION                              */
/*                               List  Methods                                */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/* Author: Gary S. Krajci                                                     */
/* Email: gary.s.krajci@bigfoot.com                                           */
/* Company: Roaring Fork Software                                             */
/* Date: July 30, 2000                                                        */
/* URL: http://www.roaringforksoftware.com/JSV/                               */
/* Script Type: JavaScript                                                    */
/* -------------------------------------------------------------------------- */

String.prototype.listFind = _listFind;
function _listFind(expV, delimiter) {
	return JSV_listFind(this, expV, delimiter);
}

String.prototype.listFindNoCase = _listFindNoCase;
function _listFindNoCase(expV, delimiter) {
	return JSV_listFindNoCase(this, expV, delimiter);
}

String.prototype.listGetAt = _listGetAt;
function _listGetAt(expN, delimiter) {
	return JSV_listGetAt(this, expN, delimiter);
}

String.prototype.listLen = _listLen;
function _listLen(delimiter) {
	return JSV_listLen(this, delimiter);
}

String.prototype.listAppend = _listAppend;
function _listAppend(expE, delimiter) {
	return JSV_listAppend(this, expE, delimiter);
}

String.prototype.listDelete = _listDelete;
function _listDelete(expN, delimiter, caseSensitive) {
	return JSV_listDelete(this, expN, delimiter, caseSensitive);
}

function JSV_listFind(expL, expV, delimiter) {
	var listLocation = 0;

	if (delimiter == null) delimiter = jsvCommaDelimiter;

	if ( !JSV_isEmpty(JSV_listFind.arguments[0]) && !JSV_isEmpty(JSV_listFind.arguments[1]) ) {
		var i = 0;
		var listArray = JSV_splitString(expL, delimiter);

		for (i=0; i<listArray.length; i++) {
			if ( JSV_toString(expV) == JSV_toString(listArray[i]) ) {
				listLocation = i+1;
				break;
			}
		}
	}

	return listLocation;
}

function JSV_listFindNoCase(expL, expV, delimiter) {
	return JSV_listFind(JSV_toString(expL).toLowerCase(), JSV_toString(expV).toLowerCase(), delimiter);
}

function JSV_listGetAt(expL, expN, delimiter) {
	if (delimiter == null) delimiter = jsvCommaDelimiter;
	var listArray = JSV_splitString(expL, delimiter);
	return ( (expN > listArray.length) ? null : listArray[expN-1] );
}

function JSV_listLen(expL, delimiter) {
	if (delimiter == null) delimiter = ',';
	return JSV_occurs(expL, delimiter) + ( JSV_isWhitespace(expL) ? 0 : 1 );
}

function JSV_listAppend(expL, expE, delimiter) {
	if ( JSV_isEmpty(expL) )
		return expE;
	else
		return expL + ( (JSV_listAppend.arguments[2] == null) ? ',' : delimiter ) + expE;
}

function JSV_listDelete(expL, expN, delimiter, caseSensitive) {
	if (delimiter == null) delimiter = jsvCommaDelimiter;
	if (caseSensitive == null) caseSensitive = false;

	var updatedList = expL;
	var interToken = ( caseSensitive ? expN : expN.toLowerCase() );

	if ( !JSV_isWhitespace(updatedList) ) {
		if ( JSV_listLen(updatedList, delimiter) == 1 ) {
			var interList = ( caseSensitive ? updatedList : updatedList.toLowerCase() )
			if ( interList == interToken ) updatedList = '';
		}
		else {
			var i = 0;
			var arrayItem = updatedList = '';
			var listArray = JSV_splitString(expL, delimiter);
			for (i=0; i<listArray.length; i++) {
				arrayItem = ( caseSensitive ? listArray[i] : listArray[i].toLowerCase() );
				if ( arrayItem != interToken ) {
					updatedList = JSV_listAppend(updatedList, listArray[i], delimiter);
				}
			}
		}
	}

	return updatedList;
}
